Ubuntu – Can’t uninstall Python 3.6

pythonpython3uninstall

I want to uninstall my 3.6 version without touching the original 3.5 version. So I ran

sudo apt-get remove python3.6

but the output was:

E: Unable to locate package python3.6
E: Couldn't find any package by glob 'python3.6'
E: Couldn't find any package by regex 'python3.6'
$ dpkg -l python3.6
dpkg-query: no packages found matching python3.6

$ dpkg -l python3
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Inst/Conf-files/Unpacked/halF-conf/Half-inst/trig-aWait/Trig-pend
|/ Err?=(none)/Reinst-required (Status,Err: uppercase=bad)
||/ Name           Version      Architecture Description
+++-==============-============-============-=================================
ii  python3        3.5.1-3      amd64        interactive high-level object-ori
$ apt-cache policy python3
python3:
  Installed: 3.5.1-3
  Candidate: 3.5.1-3
  Version table:
 *** 3.5.1-3 500
        500 http://in.archive.ubuntu.com/ubuntu xenial/main amd64 Packages
        100 /var/lib/dpkg/status

My goal is described in Ubuntu 16.04 : Can't seem to make numpy work in python 3.6.5 but it works fine in python 2.7.12. I'm unable to make my code run in neither of python2.7, python3.5, python 3.6. I'm fine with whatever Python version so long as I'm able to run my code.

$ type python
python is hashed (/usr/bin/python)
$ type python3
python3 is hashed (/usr/local/bin/python3)
$ type python3.6
python3.6 is hashed (/usr/local/bin/python3.6)
$ apt list --installed 'python*'
Listing... Done
python/xenial-updates,now 2.7.12-1~16.04 amd64 [installed]
python-all/xenial-updates,now 2.7.12-1~16.04 amd64 [installed,automatic]
python-all-dev/xenial-updates,now 2.7.12-1~16.04 amd64 [installed,automatic]
python-apt-common/xenial-updates,xenial-updates,now 1.1.0~beta1ubuntu0.16.04.1 all [installed]
python-crypto/xenial-updates,xenial-security,now 2.6.1-6ubuntu0.16.04.3 amd64 [installed]
python-dbus/xenial,now 1.2.0-3 amd64 [installed,automatic]
python-dev/xenial-updates,now 2.7.12-1~16.04 amd64 [installed,automatic]
python-gi/xenial,now 3.20.0-0ubuntu1 amd64 [installed,automatic]
python-ldb/xenial,now 2:1.1.24-1ubuntu3 amd64 [installed]
python-minimal/xenial-updates,now 2.7.12-1~16.04 amd64 [installed]
python-numpy/xenial,now 1:1.11.0-1ubuntu1 amd64 [installed]
python-pip/xenial-updates,xenial-updates,now 8.1.1-2ubuntu0.4 all [installed]
python-pip-whl/xenial-updates,xenial-updates,now 8.1.1-2ubuntu0.4 all [installed,automatic]
python-pkg-resources/xenial,xenial,now 20.7.0-1 all [installed,automatic]
python-pyatspi/xenial,xenial,now 2.18.0+dfsg-3 all [installed,automatic]
python-samba/xenial-updates,xenial-security,now 2:4.3.11+dfsg-0ubuntu0.16.04.13 amd64 [installed]
python-setuptools/xenial,xenial,now 20.7.0-1 all [installed,automatic]
python-talloc/xenial,now 2.1.5-2 amd64 [installed]
python-tdb/xenial,now 1.3.8-2 amd64 [installed]
python-wheel/xenial,xenial,now 0.29.0-1 all [installed,automatic]
python2.7/xenial-updates,now 2.7.12-1ubuntu0~16.04.3 amd64 [installed]
python2.7-dev/xenial-updates,now 2.7.12-1ubuntu0~16.04.3 amd64 [installed,automatic]
python2.7-minimal/xenial-updates,now 2.7.12-1ubuntu0~16.04.3 amd64 [installed]
python3/xenial,now 3.5.1-3 amd64 [installed]
python3-apport/xenial-updates,xenial-updates,now 2.20.1-0ubuntu2.17 all [installed]
python3-apt/xenial-updates,now 1.1.0~beta1ubuntu0.16.04.1 amd64 [installed]
python3-aptdaemon/xenial,xenial,now 1.1.1+bzr982-0ubuntu14 all [installed]
python3-aptdaemon.gtk3widgets/xenial,xenial,now 1.1.1+bzr982-0ubuntu14 all [installed]
python3-aptdaemon.pkcompat/xenial,xenial,now 1.1.1+bzr982-0ubuntu14 all [installed]
python3-blinker/xenial,xenial,now 1.3.dfsg2-1build1 all [installed]
python3-brlapi/xenial-updates,now 5.3.1-2ubuntu2.1 amd64 [installed]
python3-bs4/xenial,xenial,now 4.4.1-1 all [installed]
python3-cairo/xenial,now 1.10.0+dfsg-5build1 amd64 [installed]
python3-cffi-backend/xenial,now 1.5.2-1ubuntu1 amd64 [installed]
python3-chardet/xenial,xenial,now 2.3.0-2 all [installed]
python3-checkbox-support/xenial,xenial,now 0.22-1 all [installed]
python3-commandnotfound/xenial-updates,xenial-updates,now 0.3ubuntu16.04.2 all [installed]
python3-cryptography/xenial-updates,xenial-security,now 1.2.3-1ubuntu0.1 amd64 [installed]
python3-cups/xenial,now 1.9.73-0ubuntu2 amd64 [installed]
python3-cupshelpers/xenial,xenial,now 1.5.7+20160212-0ubuntu2 all [installed]
python3-dateutil/xenial,xenial,now 2.4.2-1 all [installed,automatic]
python3-dbus/xenial,now 1.2.0-3 amd64 [installed]
python3-debian/xenial,xenial,now 0.1.27ubuntu2 all [installed]
python3-defer/xenial,xenial,now 1.0.6-2build1 all [installed]
python3-dev/xenial,now 3.5.1-3 amd64 [installed,automatic]
python3-distupgrade/xenial-updates,xenial-updates,xenial-security,xenial-security,now 1:16.04.25 all [installed]
python3-feedparser/xenial,xenial,now 5.1.3-3build1 all [installed]
python3-gdbm/xenial,now 3.5.1-1 amd64 [installed]
python3-gi/xenial,now 3.20.0-0ubuntu1 amd64 [installed]
python3-gi-cairo/xenial,now 3.20.0-0ubuntu1 amd64 [installed]
python3-guacamole/xenial,xenial,now 0.9.2-1 all [installed]
python3-html5lib/xenial,xenial,now 0.999-4 all [installed]
python3-httplib2/xenial,xenial,now 0.9.1+dfsg-1 all [installed]
python3-icu/xenial,now 1.9.2-2build1 amd64 [installed]
python3-idna/xenial,xenial,now 2.0-3 all [installed]
python3-jinja2/xenial,xenial,now 2.8-1 all [installed]
python3-jwt/xenial-updates,xenial-updates,xenial-security,xenial-security,now 1.3.0-1ubuntu0.1 all [installed]
python3-louis/xenial-updates,xenial-updates,xenial-security,xenial-security,now 2.6.4-2ubuntu0.1 all [installed]
python3-lxml/xenial,now 3.5.0-1build1 amd64 [installed]
python3-mako/xenial,xenial,now 1.0.3+ds1-1ubuntu1 all [installed]
python3-markupsafe/xenial,now 0.23-2build2 amd64 [installed]
python3-minimal/xenial,now 3.5.1-3 amd64 [installed]
python3-oauthlib/xenial,xenial,now 1.0.3-1 all [installed]
python3-padme/xenial,xenial,now 1.1.1-2 all [installed]
python3-pam/xenial,now 0.4.2-13.2ubuntu2 amd64 [installed]
python3-pexpect/xenial,xenial,now 4.0.1-1 all [installed]
python3-pil/xenial-updates,xenial-security,now 3.1.2-0ubuntu1.1 amd64 [installed]
python3-pip/xenial-updates,xenial-updates,now 8.1.1-2ubuntu0.4 all [installed]
python3-pkg-resources/xenial,xenial,now 20.7.0-1 all [installed]
python3-plainbox/xenial,xenial,now 0.25-1 all [installed]
python3-problem-report/xenial-updates,xenial-updates,now 2.20.1-0ubuntu2.17 all [installed]
python3-ptyprocess/xenial,xenial,now 0.5-1 all [installed]
python3-pyasn1/xenial,xenial,now 0.1.9-1 all [installed]
python3-pyatspi/xenial,xenial,now 2.18.0+dfsg-3 all [installed]
python3-pycurl/xenial,now 7.43.0-1ubuntu1 amd64 [installed]
python3-pyparsing/xenial-updates,xenial-updates,now 2.0.3+dfsg1-1ubuntu0.1 all [installed]
python3-renderpm/xenial,now 3.3.0-1 amd64 [installed]
python3-reportlab/xenial,xenial,now 3.3.0-1 all [installed]
python3-reportlab-accel/xenial,now 3.3.0-1 amd64 [installed]
python3-requests/xenial,xenial,now 2.9.1-3 all [installed]
python3-setuptools/xenial,xenial,now 20.7.0-1 all [installed,automatic]
python3-six/xenial,xenial,now 1.10.0-3 all [installed]
python3-software-properties/xenial-updates,xenial-updates,now 0.96.20.7 all [installed]
python3-speechd/xenial,xenial,now 0.8.3-1ubuntu3 all [installed]
python3-systemd/xenial,now 231-2build1 amd64 [installed]
python3-tk/xenial,now 3.5.1-1 amd64 [installed]
python3-uno/xenial-updates,xenial-security,now 1:5.1.6~rc2-0ubuntu1~xenial3 amd64 [installed]
python3-update-manager/xenial-updates,xenial-updates,xenial-security,xenial-security,now 1:16.04.12 all [installed]
python3-urllib3/xenial-updates,xenial-updates,now 1.13.1-2ubuntu0.16.04.1 all [installed]
python3-wheel/xenial,xenial,now 0.29.0-1 all [installed,automatic]
python3-xdg/xenial,xenial,now 0.25-4 all [installed]
python3-xkit/xenial,xenial,now 0.5.0ubuntu2 all [installed]
python3-xlsxwriter/xenial,xenial,now 0.7.3-1 all [installed]
python3.5/xenial-updates,xenial-security,now 3.5.2-2ubuntu0~16.04.4 amd64 [installed]
python3.5-dev/xenial-updates,xenial-security,now 3.5.2-2ubuntu0~16.04.4 amd64 [installed,automatic]
python3.5-minimal/xenial-updates,xenial-security,now 3.5.2-2ubuntu0~16.04.4 amd64 [installed]

Best Answer

  • Your python3 and python3.6 binaries1 are installed in /usr/local/bin which is not the default location and dpkg (or APT) does not know about them. So they weren’t most likely installed by dpkg or APT. To uninstall them, just remove them from the /usr/local/bin folder.

    Preliminary check

    I recommend to rename them first:

    sudo mv /usr/local/bin/python3 /usr/local/bin/python3.bak
    sudo mv /usr/local/bin/python3.6 /usr/local/bin/python3.6.bak
    

    Then check whether the version installed by APT kicks in when you run python3:

    python3 --version # expected output: Python 3.5.2
    

    If this check succeeds, you can safely remove the files /usr/local/bin/python3.bak and /usr/local/bin/python3.6.bak.


    1 In fact, one file might be a symlink to the other.

  • Related Question